#ifndef LEADERPKG_H_DEF
#define LEADERPKG_H_DEF

#include "TelepatiPkg.h"

using namespace std;

/**implementa il messaggio di saluto del Leader.  Messaggio spedito
   dal Leader all'avvio per informare gli other della sua presenza.
   Struttura: e' composto esclusivamente dall'header standard
*/

class LeaderPkg : public TelepatiPkg{
 public:
  /** Costruttore ordinario.  @param a aibo di destinazione @param ack
      se ha bisogno o meno dell'Ack*/
  LeaderPkg(int a, bool ack);
  /**Costruisce l'oggetto a partire dall'array restituito da
     getMsg(). @param ptr puntatore all'array di byte. @see
     getMsg()*/
  LeaderPkg(byte* ptr);

  /** Distruttore di Default.*/
  virtual ~LeaderPkg();

  /** Clonatore. Restituisce un clone dell'oggetto su cui e'
      chiamato.*/
  virtual TelepatiPkg* clone();

  /** Ritorna un array che rappresenta l'oggetto. Costruisce un array
      che rappresenta l'oggetto, l'array corrisponde ai dati spediti
      via rete. @return array di byte. @see LeaderPkg(byte* ptr)*/
  byte* getMsg();  
};

#endif
